/* 
 * Copyright 2007 TAKAI Naoto <takai@recompile.net>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

package net.recompile.webdb.comet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.concurrent.atomic.AtomicInteger;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.sun.enterprise.web.connector.grizzly.comet.CometContext;
import com.sun.enterprise.web.connector.grizzly.comet.CometEngine;

/**
 * O|[OŁACometT[ubgB
 * tH[Go[t[ł̎Ƃ̑_́Ao^CometHandlerƃReLXgpẌႢ̂݁B
 * 
 * @author TAKAI Naoto <takai@recompile.net>
 */
public class LongPollingServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	/** T[ubg̃ReLXgpX */
	private String contextPath = null;

	/** JE^[ */
	private final AtomicInteger counter = new AtomicInteger();

	/** O */
	private final Logger logger = LoggerFactory
			.getLogger(LongPollingServlet.class);

	/**
	 * GETNGXgB
	 */
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		// CometHandler쐬AX|XIuWFNgƊ֘AtB
		LongPollingCometHandler handler = new LongPollingCometHandler(counter);
		handler.attach(res);

		// 쐬CometHandlerCometContextƊ֘AtB
		CometEngine engine = CometEngine.getEngine();
		CometContext context = engine.getCometContext(contextPath);
		context.addCometHandler(handler);

		logger.info("CometHandler({})̃CX^X쐬ACometContext({})ɓo^܂B",
				handler.toString(), contextPath);

		// X|X̕ԋṕACometContextLbNACometHandlerŏB
	}

	/**
	 * POSTNGXgB
	 */
	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		// JE^[𑝉B
		logger.info("JE^[̒l{}ЂƂ܂B", counter.get());
		counter.getAndIncrement();

		// NCAg֏Ԃ̕ωʒmB
		logger.info("CometContext({})ɓo^ꂽCometHandlerɒʒm܂B", contextPath);
		CometEngine engine = CometEngine.getEngine();
		CometContext<?> context = engine.getCometContext(contextPath);
		context.notify(null);

		// POSTNGXgɑ΂āAX|XԂB
		logger.info("POSTNGXgɑ΂āAusuccessvƂX|XԂ܂B");
		PrintWriter writer = res.getWriter();
		writer.write("success");
		writer.flush();
	}

	/**
	 * T[ubg̏sȂB
	 */
	@Override
	public void init(ServletConfig config) throws ServletException {
		ServletContext context = config.getServletContext();
		contextPath = context.getContextPath() + "/long_polling";

		// ReLXgpXL[CometEngineCometContexto^B
		logger.info("CometEngineCometContext({})o^܂B", contextPath);
		CometEngine engine = CometEngine.getEngine();
		CometContext cometContext = engine.register(contextPath);
		cometContext.setExpirationDelay(300000L);
	}

}
